/* Created by Language version: $Revision: 1.6 $  of $Date: 1994/11/04 18:13:56 $ */
/* NOT VECTORIZED */
#include <stdio.h>
#include <math.h>
#include "scoplib.h"
#undef PI
 
#include "md1redef.h"
#include "section.h"
#include "md2redef.h"

#if METHOD3
extern int _method3;
#endif
 	/*SUPPRESS 761*/
	/*SUPPRESS 762*/
	/*SUPPRESS 763*/
	/*SUPPRESS 765*/
	 extern double *getarg();
 static double *_p; static Datum *_ppvar;
 
#define delta_t dt
#define gain _p[0]
#define rstim _p[1]
#define tau1 _p[2]
#define tau2 _p[3]
#define e0 _p[4]
#define vo0 _p[5]
#define vi0 _p[6]
#define fac _p[7]
#define i _p[8]
#define dur (_p + 9)
#define amp (_p + 12)
#define e _p[15]
#define vo _p[16]
#define vi _p[17]
#define stim _p[18]
#define tc _p[19]
#define De _p[20]
#define Dvo _p[21]
#define Dvi _p[22]
#define _nd_area  *_ppvar[0].pval
 static int hoc_nrnpointerindex =  -1;
 /* external NEURON variables */
 extern double dt;
 extern double t;
 /* declaration of user functions */
 static double _hoc_icur();
 static double _hoc_update();
 static double _hoc_vstim();
 static int _mechtype;
extern int nrn_get_mechtype();
 static int _pointtype;
 static void* _hoc_create_pnt(_ho) Object* _ho; { void* create_point_process();
 return create_point_process(_pointtype, _ho);
}
 static void _hoc_destroy_pnt(_vptr) void* _vptr; { destroy_point_process(_vptr);}
 static double _hoc_loc_pnt(_vptr) void* _vptr; {double loc_point_process();
 return loc_point_process(_pointtype, _vptr);
}
 static double _hoc_has_loc(_vptr) void* _vptr; {double has_loc_point();
 return has_loc_point(_vptr);
}
 static double _hoc_get_loc_pnt(_vptr)void* _vptr; {
 double get_loc_point_process(); return (get_loc_point_process(_vptr));
}
 static _hoc_setdata(_vptr) void* _vptr; { Prop* _prop;
 _prop = ((Point_process*)_vptr)->prop;
 _p = _prop->param; _ppvar = _prop->dparam;
 }
 /* connect user functions to hoc names */
 static IntFunc hoc_intfunc[] = {
 0,0
};
 static struct Member_func {
	char* _name; double (*_member)();} _member_func[] = {
 "loc", _hoc_loc_pnt,
 "has_loc", _hoc_has_loc,
 "get_loc", _hoc_get_loc_pnt,
 "icur", _hoc_icur,
 "update", _hoc_update,
 "vstim", _hoc_vstim,
 0, 0
};
#define icur icur_VClamp
 extern double icur();
 /* declare global and static user variables */
 static double t0 = 0;
 static double v = 0;
 /* connect global user variables to hoc */
 static DoubScal hoc_scdoub[] = {
 0,0
};
 static DoubVec hoc_vdoub[] = {
 0,0,0
};
 static double _sav_indep;
 static nrn_alloc(), nrn_init(), nrn_cur(), nrn_state();
 /* connect range variables in _p that hoc is supposed to know about */
 static char *_mechanism[] = {
 "VClamp",
 "gain",
 "rstim",
 "tau1",
 "tau2",
 "e0",
 "vo0",
 "vi0",
 "fac",
 0,
 "i",
 "dur[3]",
 "amp[3]",
 0,
 "e",
 "vo",
 "vi",
 0,
 0};
 
static nrn_alloc(_prop)
	Prop *_prop;
{
	Prop *prop_ion, *need_memb();
	double *_p; Datum *_ppvar;
 	_p = (double *)ecalloc(23, sizeof(double));
 	_prop->param = _p;
 	_prop->param_size = 23;
 	/*initialize range parameters*/
 	gain = 100000;
 	rstim = 1;
 	tau1 = 0.001;
 	tau2 = 0;
 	e0 = 0;
 	vo0 = 0;
 	vi0 = 0;
 	fac = 0;
 	_ppvar = (Datum *)ecalloc(2, sizeof(Datum));
 	_prop->dparam = _ppvar;
 	/*connect ionic variables to this model*/
 
}
 static _initlists();
 _vclmp_reg() {
	int _vectorized = 0;
  _initlists();
 	_pointtype = point_register_mech(_mechanism,
	 nrn_alloc, nrn_cur, nrn_state, nrn_init,
	 hoc_nrnpointerindex,
	 _hoc_create_pnt, _hoc_destroy_pnt, _member_func,
	 _vectorized);
 _mechtype = nrn_get_mechtype(_mechanism[0]);
 	hoc_register_var(hoc_scdoub, hoc_vdoub, hoc_intfunc);
 	ivoc_help("help ?1 VClamp /timshel2h/home/hines/nrn/src/nrnoc/vclmp.mod\n");
 }
static int _reset;
static char *modelname = "vclmp2.mod";

static int error;
static int _ninits = 0;
static int _match_recurse=1;
static _modl_cleanup(){ _match_recurse=1;}
static update();
static vstim();
 
#define _RHS1(arg) _coef1[arg][3]
 static int _slist1[3];static double **_coef1;
 static int clamp();
 
static int  vstim (  )  {
   tc = 0.0 ;
   {int  _lj ;for ( _lj = 0 ; _lj <= 3 - 1 ; _lj ++ ) {
     stim = amp [ _lj ] ;
     tc = tc + dur [ _lj ] ;
     if ( t < tc ) {
       tc = tc + 100.0 ;
       
/*VERBATIM*/

			break;
 }
     } }
    return 0; }
 static double _hoc_vstim(_vptr) void* _vptr; {
 double _r;
 	_hoc_setdata(_vptr);
 _r = 1.;
 vstim (  ) ;
 return(_r);
}
 
double icur (  )  {
   double _licur;
 double _lvout ;
 if ( t > tc ) {
     e0 = 0.0 ;
     vo0 = 0.0 ;
     _licur = 0.0 ;
     }
   else {
     error =  0; clamp();
 error = simeq(3, _coef1, _p, _slist1);
 if(error){fprintf(stderr,"at line 134 in file vclmp.mod:\n		SOLVE clamp\n"); nrn_complain(_p); abort_run(error);}
 _licur = ( vo - v ) / rstim ;
     }
   
return _licur;
 }
 static double _hoc_icur(_vptr) void* _vptr; {
 double _r;
 	_hoc_setdata(_vptr);
 _r =  icur (  ) ;
 return(_r);
}
 
static int clamp ()
 {
   zero_matrix(_coef1, 3, 4);
{
  int _counte = -1;
 double _lt1 , _lt2 ;
 _lt1 = tau1 / dt ;
   _lt2 = tau2 / dt ;
    ++_counte;
 _coef1[_counte][0] -=  1.0 ;
 _RHS1(_counte) -=  v ;
 _coef1[_counte][1] +=  fac * 1.0 ;
 _RHS1(_counte) +=  fac * v ;
   ;
  ++_counte;
 _coef1[_counte][1] -=  _lt2 * 1.0 ;
 _RHS1(_counte) -=  _lt2 * vo0 ;
 _coef1[_counte][1] -=  1.0 ;
 _coef1[_counte][2] -=  gain * 1.0 ;
   ;
  ++_counte;
 _RHS1(_counte) -=  stim ;
 _coef1[_counte][2] +=  1.0 ;
 _coef1[_counte][0] -=  1.0 ;
 _coef1[_counte][2] +=  1.0 ;
 _coef1[_counte][0] -=  _lt1 * 1.0 ;
 _coef1[_counte][2] +=  _lt1 * 1.0 ;
 _RHS1(_counte) -=  _lt1 * ( vi0 - e0 ) ;
 _RHS1(_counte) -=  0.0 ;
   ;
 
}
 }
 
static int  update (  )  {
   i = icur (  ) ;
   e0 = e ;
   vo0 = vo ;
   vi0 = vi ;
   
/*VERBATIM*/

	return 0;
  return 0; }
 static double _hoc_update(_vptr) void* _vptr; {
 double _r;
 	_hoc_setdata(_vptr);
 _r = 1.;
 update (  ) ;
 return(_r);
}

static initmodel() {
  int _i; double _save;_ninits++;
 _save = t;
 t = t0;
{
  e = e0;
  vi = vi0;
  vo = vo0;
 {
   e0 = 0.0 ;
   vo = v ;
   vo0 = v ;
   vi = v ;
   vi0 = v ;
   e = 0.0 ;
   }
  _sav_indep = t; t = _save;

}
}

static nrn_init(_nd, _pp, _ppd) Node *_nd; double *_pp; Datum* _ppd; {
 double _v;
 _p = _pp; _ppvar = _ppd;
#if EXTRACELLULAR
 if (_nd->_extnode) {
    _v = _nd->_v +_nd->_extnode->_v;
 }else
#endif
 {
    _v = _nd->_v;
 }
 v = _v;
 initmodel();
}

static double _nrn_current(_v) double _v;{double _current=0.;v=_v;{ {
   vstim (  ) ;
   i = icur (  ) ;
   }
 _current += i;

} return _current;
}

static nrn_cur(_nd, _pp, _ppd) Node *_nd;double *_pp; Datum* _ppd; {
 double _g, _rhs, _v, *_pdiag;
 _p = _pp; _ppvar = _ppd;
_pdiag = &_nd->_d;
#if EXTRACELLULAR
 if (_nd->_extnode) {
    _v = _nd->_v +_nd->_extnode->_v;
 }else
#endif
 {
    _v = _nd->_v;
 }
 _g = _nrn_current(_v + .001);
 	{ _rhs = _nrn_current(_v);
 	}
 _g = (_g - _rhs)/.001;
 _g *=  1.e2/(_nd_area);
 _rhs *= 1.e2/(_nd_area);
 _rhs -= _g*_v;
 *_pdiag -= _g;
 _nd->_rhs += _rhs;
#if EXTRACELLULAR
 if (_nd->_extnode) {
   _nd->_extnode->_d += _g;
   _nd->_extnode->_rhs += _rhs;
 }
#endif
 
}

static nrn_state(_nd, _pp, _ppd) Node *_nd; double *_pp; Datum* _ppd; {
 double _break, _save;
 double _v;
 _p = _pp; _ppvar = _ppd;
#if EXTRACELLULAR
 if (_nd->_extnode) {
    _v = _nd->_v +_nd->_extnode->_v;
 }else
#endif
 {
    _v = _nd->_v;
 }
 _break = t + .5*dt; _save = t; delta_t = dt;
 v=_v;
{
 { {
 for (; t < _break; t += delta_t) {
 error =  update();
 if(error){fprintf(stderr,"at line 103 in file vclmp.mod:\n	SOLVE update\n"); nrn_complain(_p); abort_run(error);}
 
}}
 t = _save;
 }
}
}

static terminal(){}

static _initlists() {
 int _i; static int _first = 1;
  if (!_first) return;
 _slist1[0] = &(vi) - _p;
 _slist1[1] = &(vo) - _p;
 _slist1[2] = &(e) - _p;
 if (_first) _coef1 = makematrix(3, 4);
_first = 0;
}
