/* $Header: /timshel2g/src/master/nrn/src/oc/code.h,v 1.2 1994/10/28 15:17:54 hines Exp $ */
/* $Log: code.h,v $
 * Revision 1.2  1994/10/28  15:17:54  hines
 * yet another common name defined in an include file. this time ALPHA
 *
 * Revision 1.1.1.1  1994/10/12  17:22:02  hines
 * NEURON 3.0 distribution
 *
 * Revision 2.103  1994/07/12  13:45:48  hines
 * can use constant objects of form
 * template[index].
 * now object names are printed in this format as well.
 *
 * Revision 2.30  1993/03/02  08:30:03  hines
 * parallization of shortfor loop as in
 * parallel for i=1,10 print i
 *
 * Revision 1.17  92/12/18  15:10:36  hines
 * fix bug in which pointers to range variables in object not allowed.
 * 
 * Revision 1.16  92/10/27  09:16:51  hines
 * rangevar(x) = y is an allowed syntax and sets the value at the segment that
 * contains x
 * 
 * Revision 1.15  92/10/10  12:31:41  hines
 * old section list syntax discarded in favor of making them first class
 * objects.
 * style is
 * objectvar s
 * s = new SectionList()
 * sec s.append()
 * sec s.remove()
 * forsec s
 * ifsec s
 * 
 * Revision 1.14  92/10/09  12:16:07  hines
 * remove old style point process syntax
 * make hoc_run_expr(sym) much more general
 * added hoc_run_stmt(sym) as well
 * create them with hoc_parse_expr(char*, Symlist**) and
 * hoc_parse_stmt(char*, Symlist**)
 * 
 * Revision 1.13  92/10/07  13:51:05  hines
 * strings can be passed as args and read and set with $S1 = $S2
 * 
 * Revision 1.12  92/10/07  10:43:58  hines
 * a simpler connect statement is now available in addition to the old
 * baroque syntax. it is
 * connect sec1(x), sec2(0 or 1)
 * 
 * Revision 1.11  92/08/15  12:41:25  hines
 * can pass object variable as arg to oc functions and procedures. Within
 * the procedures the syntax is
 * $$1.ob.ob.var etc.
 * see test7.hoc for usage with array of strings
 * 
 * Revision 1.10  92/08/12  16:16:08  hines
 * uninsert mechanism_name
 * 
 * Revision 1.9  92/08/10  15:59:30  hines
 * lists of sections with seclistdef ,,,
 * append_seclist(seclist)
 * remove_seclist(seclist)
 * forsec seclist
 * ifsec seclist
 * 
 * 
 * Revision 1.8  92/08/08  12:57:33  hines
 * access object.section
 * 
 * Revision 1.7  92/07/31  12:00:48  hines
 * forsec and ifsec merged from hoc/neuron
 * 
 * Revision 1.6  92/02/19  15:01:54  hines
 * preparing for sections within objects. syntax is
 * ob.section stmt    section.var
 * this causes about 36 extra shift/reduce conflicts
 * 
 * Revision 1.5  92/02/05  08:40:45  hines
 * Can connect a NEURON {POINTER var,...} in models to external variables using
 * connect var_suffix, anyvar
 * 
 * Revision 1.4  91/10/22  15:47:04  hines
 * objects and components. can assign, evaluate, and print.
 * No object arrays or function components yet.
 * At level of test3.hoc
 * 
 * Revision 1.3  91/10/16  07:32:29  hines
 * prototype of type checking
 * 
 * Revision 1.2  91/10/14  17:35:26  hines
 * scaffolding for oop in place. Syntax about right. No action yet.
 * 
 * Revision 1.1  91/10/11  11:12:25  hines
 * Initial revision
 * 
 * Revision 4.30  91/08/06  08:59:34  hines
 * when new variables are assigned a value for the first time a message
 * is printed to that effect.  scalar variables can be deleted using
 * 	delete varname
 * This change was donated by Jack Wathey
 * 
 * Revision 4.29  91/06/20  08:17:22  hines
 * print a,b,c,... prints newline after last arg.
 * 
 * Revision 4.17  91/03/18  10:40:37  hines
 * some builtin functions take address of varname. eg. regraph(&name)
 * regraph saves list of addresses for fast plotting
 * 
 * Revision 4.7  90/12/13  13:09:18  hines
 * NRNPNTVAR is a neuron point variable
 * 
 * Revision 3.21  89/08/29  10:13:11  mlh
 * forall loop over sections, create instead of section, insert instead
 * of open membrane, access instead of open section
 * 
 * Revision 3.17  89/08/12  12:32:02  mlh
 * range variable may have no argument in expression
 * 
 * Revision 3.16  89/08/10  11:10:35  mlh
 * var.sec syntax; stack sections;
 * 
 * Revision 3.14  89/08/08  08:48:53  mlh
 * for(x) syntax for looping over segments
 * 
 * Revision 3.13  89/08/02  16:14:35  mlh
 * range variables work with newcable. access changed to open
 * 
 * Revision 3.12  89/07/27  16:16:18  mlh
 * at point in newcable where topology() works
 * 
 * Revision 3.9  89/07/20  09:53:54  mlh
 * declare newcable code
 *  */

extern	eval(), add(), sub(), mul(), hoc_div(), hoc_cyclic(), negate(), power();
extern	assign(), bltin(), varpush(), constpush(), print(), varread();
extern	nopop(), prexpr(), prstr(), assstr(), pushzero();
extern	gt(), lt(), eq(), ge(), le(), ne(), and(), or(), not();
extern	ifcode(), forcode(), shortfor(), call(), arg(), argassign();
extern	funcret(), procret(), Break(), Continue(), Stop();
extern	debug(), edit(), hoc_evalpointer();
extern	hoc_newline(), hoc_delete_symbol(), hoc_stringarg(), hoc_push_string();
extern	hoc_parallel_begin(), hoc_parallel_end();

/* OOP */
extern hoc_objectvar(), hoc_object_component(), hoc_object_eval();
extern hoc_object_asgn(), hoc_objvardecl(), hoc_cmp_otype(), hoc_newobj();
extern hoc_asgn_obj_to_str(), hoc_known_type(), hoc_push_string();
extern hoc_objectarg(), hoc_ob_pointer(), hoc_constobject();
/* END OOP */

/* NEWCABLE */
extern	connectsection(), add_section(), range_const(), range_interpolate();
extern	clear_sectionlist(), install_sectionlist();
extern  rangevareval(), sec_access(), mech_access(), for_segment();
extern	sec_access_temp(), sec_access_push(), sec_access_pop();
extern	rangepoint(), forall_section(), hoc_ifsec();
extern	rangevarevalpointer();
extern	connectpointer(), connect_point_process_pointer(), nrn_cppp();
extern  ob_sec_access(), sec_access_object();
extern	forall_sectionlist();
extern	hoc_ifseclist(), mech_uninsert();
extern	simpleconnectsection(), range_interpolate_single();
/* END NEWCABLE*/
