/* $Header: /timshel2g/src/master/nrn/src/oc/nocable.c,v 1.1.1.1 1994/10/12 17:22:11 hines Exp $ */
/* $Log: nocable.c,v $
 * Revision 1.1.1.1  1994/10/12  17:22:11  hines
 * NEURON 3.0 distribution
 *
 * Revision 2.102  1994/07/04  15:10:54  hines
 * only print Oc banner if not NEURON
 *
 * Revision 2.16  1993/01/22  17:34:21  hines
 * ocmodl, ivmodl working both for shared and static libraries
 *
 * Revision 2.5  93/01/06  09:26:20  hines
 * cray c90 needs include <errno.h>   remove some codecenter warnings
 * 
 * Revision 1.12  92/12/31  15:30:54  hines
 * modl_set_dt stub here
 * 
 * Revision 1.11  92/10/27  09:17:45  hines
 * rangevar(x) = y is an allowed syntax and sets the value at the segment that
 * contains x
 * 
 * Revision 1.10  92/10/09  12:16:11  hines
 * remove old style point process syntax
 * make hoc_run_expr(sym) much more general
 * added hoc_run_stmt(sym) as well
 * create them with hoc_parse_expr(char*, Symlist**) and
 * hoc_parse_stmt(char*, Symlist**)
 * 
 * Revision 1.9  92/10/07  10:45:09  hines
 * a simpler connect statement is now available in addition to the old
 * baroque syntax. it is
 * connect sec1(x), sec2(0 or 1)
 * 
 * Revision 1.8  92/08/12  16:16:14  hines
 * uninsert mechanism_name
 * 
 * Revision 1.7  92/08/10  15:59:37  hines
 * lists of sections with seclistdef ,,,
 * append_seclist(seclist)
 * remove_seclist(seclist)
 * forsec seclist
 * ifsec seclist
 * 
 * 
 * Revision 1.6  92/08/08  12:57:40  hines
 * access object.section
 * 
 * Revision 1.5  92/07/31  14:34:20  hines
 * avoid saber warning with hoc_xpop not declared double in nocable.c
 * 
 * Revision 1.4  92/07/31  12:01:12  hines
 * forsec and ifsec merged from hoc/neuron
 * 
 * Revision 1.3  92/02/19  15:01:59  hines
 * preparing for sections within objects. syntax is
 * ob.section stmt    section.var
 * this causes about 36 extra shift/reduce conflicts
 * 
 * Revision 1.2  92/02/05  08:42:15  hines
 * Can connect a NEURON {POINTER var,...} in models to external variables using
 * connect var_suffix, anyvar
 * 
 * Revision 1.1  91/10/11  11:12:13  hines
 * Initial revision
 * 
 * Revision 4.17  91/03/18  10:40:38  hines
 * some builtin functions take address of varname. eg. regraph(&name)
 * regraph saves list of addresses for fast plotting
 * 
 * Revision 4.7  90/12/13  13:10:16  hines
 * NRNPNTVAR is a neuron point variable
 * 
 * Revision 3.21  89/08/29  10:14:16  mlh
 * forall loop over sections, create instead of section, insert instead
 * of open membrane, access instead of open section
 * 
 * Revision 3.17  89/08/12  12:32:58  mlh
 * range variable may have no argument in expression
 * 
 * Revision 3.16  89/08/10  11:15:31  mlh
 * var.sec syntax; stack sections
 * 
 * Revision 3.13  89/08/02  16:15:33  mlh
 * range variables work with newcable. access changed to open
 * 
 * Revision 3.9  89/07/20  09:54:55  mlh
 * newcable productions have been activated in parse.y and
 * normal hoc needs the resultant code functions defined.
 *  */

/* stubs for hoc versions that do not use newcable code */

clear_sectionlist(){}
add_section(){}
install_sectionlist(){}
connectsection(){}
connectpointer(){}
sec_access(){}
range_const(){}
range_interpolate(){}
rangevareval(){}
rangevarevalpointer(){}
mech_access(){}
mech_uninsert(){}
sec_access_push(){}
sec_access_pop(){}
sec_access_temp(){}
rangepoint(){}
forall_section(){}
connect_point_process_pointer(){} nrn_cppp(){}
hoc_ifsec(){}
ob_sec_access() {double hoc_xpop(); hoc_xpop();}
sec_access_object(){}
sectionlist_decl(){}
forall_sectionlist(){}
hoc_ifseclist(){}
hoc_push_sectionlist(){}
simpleconnectsection(){}
range_interpolate_single(){}
int nrn_is_cable(){ return 0; }
