/* Created by Language version: $Revision: 1.6 $  of $Date: 1994/11/04 18:13:43 $ */
/* VECTORIZED */
#include <stdio.h>
#include <math.h>
#include "scoplib.h"
#undef PI
 
#include "md1redef.h"
#include "section.h"
#include "md2redef.h"

#if METHOD3
extern int _method3;
#endif
 	/*SUPPRESS 761*/
	/*SUPPRESS 762*/
	/*SUPPRESS 763*/
	/*SUPPRESS 765*/
	 extern double *getarg();
 static double **_p; static Datum **_ppvar;
 
#define delta_t dt
#define n _p[_ix][0]
#define thresh _p[_ix][1]
#define time _p[_ix][2]
#define firing _p[_ix][3]
#define v _p[_ix][4]
#define _nd_area  *_ppvar[_ix][0].pval
 static int hoc_nrnpointerindex =  -1;
 /* external NEURON variables */
 extern double dt;
 extern double t;
 /* declaration of user functions */
 static double _hoc_check();
 static int _mechtype;
extern int nrn_get_mechtype();
 static int _pointtype;
 static void* _hoc_create_pnt(_ho) Object* _ho; { void* create_point_process();
 return create_point_process(_pointtype, _ho);
}
 static void _hoc_destroy_pnt(_vptr) void* _vptr; { destroy_point_process(_vptr);}
 static double _hoc_loc_pnt(_vptr) void* _vptr; {double loc_point_process();
 return loc_point_process(_pointtype, _vptr);
}
 static double _hoc_has_loc(_vptr) void* _vptr; {double has_loc_point();
 return has_loc_point(_vptr);
}
 static double _hoc_get_loc_pnt(_vptr)void* _vptr; {
 double get_loc_point_process(); return (get_loc_point_process(_vptr));
}
 static _hoc_setdata(_vptr) void* _vptr; { Prop* _prop;
 _prop = ((Point_process*)_vptr)->prop;
 _p = &_prop->param; _ppvar = &_prop->dparam;
 }
 /* connect user functions to hoc names */
 static IntFunc hoc_intfunc[] = {
 0,0
};
 static struct Member_func {
	char* _name; double (*_member)();} _member_func[] = {
 "loc", _hoc_loc_pnt,
 "has_loc", _hoc_has_loc,
 "get_loc", _hoc_get_loc_pnt,
 "check", _hoc_check,
 0, 0
};
 /* declare global and static user variables */
 static double t0 = 0;
 /* connect global user variables to hoc */
 static DoubScal hoc_scdoub[] = {
 0,0
};
 static DoubVec hoc_vdoub[] = {
 0,0,0
};
 static double _sav_indep;
 static nrn_alloc(), nrn_init(), nrn_cur(), nrn_state();
 /* connect range variables in _p that hoc is supposed to know about */
 static char *_mechanism[] = {
 "APCount",
 "n",
 "thresh",
 "time",
 0,
 0,
 0,
 0};
 
static nrn_alloc(_prop)
	Prop *_prop;
{
	Prop *prop_ion, *need_memb();
	double *_p[1]; Datum *_ppvar[1]; int _ix = 0;
 	_p[0] = (double *)ecalloc(5, sizeof(double));
 	_prop->param = _p[0];
 	_prop->param_size = 5;
 	/*initialize range parameters*/
 	n = 0;
 	thresh = -20;
 	time = 0;
 	_ppvar[0] = (Datum *)ecalloc(2, sizeof(Datum));
 	_prop->dparam = _ppvar[0];
 	/*connect ionic variables to this model*/
 
}
 static _initlists();
 _apcount_reg() {
	int _vectorized = 1;
 	double* _x = &t;
	_p = &_x;
 _initlists();
 	_pointtype = point_register_mech(_mechanism,
	 nrn_alloc, nrn_cur, nrn_state, nrn_init,
	 hoc_nrnpointerindex,
	 _hoc_create_pnt, _hoc_destroy_pnt, _member_func,
	 _vectorized);
 _mechtype = nrn_get_mechtype(_mechanism[0]);
 	hoc_register_var(hoc_scdoub, hoc_vdoub, hoc_intfunc);
 	ivoc_help("help ?1 APCount /timshel2h/home/hines/nrn/src/nrnoc/apcount.mod\n");
 }
static int _reset;
static char *modelname = "";

static int error;
static int _ninits = 0;
static int _match_recurse=1;
static _modl_cleanup(){ _match_recurse=1;}
static check();
 
static int  check ( _ix ) int _ix; {
   
/*VERBATIM*/

	if (v >= thresh && !firing) {
		firing = 1;
		time = t;
		n += 1.;
	}
	if (firing && v < thresh) {
		firing = 0;
	}
	return 0;
  return 0; }
 static double _hoc_check(_vptr) void* _vptr; {
 double _r;
 	_hoc_setdata(_vptr);
 _r = 1.;
 check ( 0 ) ;
 return(_r);
}

static initmodel(_ix) int _ix; {
  int _i; double _save;{
 {
   n = 0.0 ;
   firing = 0.0 ;
   check ( _ix ) ;
   }
 
}
}

static nrn_init(_count, _nodes, _data, _pdata, _type_ignore)
	int _count, _type_ignore; Node** _nodes; double** _data; Datum** _pdata;
{ int _ix; double _v;
 _p = _data; _ppvar = _pdata;

#if _CRAY
#pragma _CRI ivdep
#endif
	for (_ix = 0; _ix < _count; ++_ix) {
 _v = _nodes[_ix]->_v;
		v = _v;
		initmodel(_ix);
	}
}

static double _nrn_current(_ix, _v) int _ix; double _v;{
 double _current=0.;v=_v;
  {
} return _current;
}

static nrn_cur(_count, _nodes, _data, _pdata, _type_ignore)
	int _count, _type_ignore; Node** _nodes; double** _data; Datum** _pdata;
{

}

static nrn_state(_count, _nodes, _data, _pdata, _type_ignore)
	int _count, _type_ignore; Node** _nodes; double** _data; Datum** _pdata;
{
 int _ix; double _v;
 double _break, _save;
 _p = _data; _ppvar = _pdata;
 _break = t + .5*dt; _save = t; delta_t = dt;

#if _CRAY
#pragma _CRI ivdep
#endif
	for (_ix = 0; _ix < _count; ++_ix) {
 _v = _nodes[_ix]->_v;
 v = _v;
	}

{
 { {
 for (; t < _break; t += delta_t) {
  
#if _CRAY
#pragma _CRI ivdep
#endif
 for (_ix = 0; _ix < _count; ++_ix) { check(_ix); }
  
}}
 t = _save;
 }}

#if _CRAY
#pragma _CRI ivdep
#endif
	for (_ix = 0; _ix < _count; ++_ix) {
 {
   }
	}
}

static terminal(){}

static _initlists(){
 int _i; int _ix=0; static int _first = 1;
  if (!_first) return;
_first = 0;
}
