/* Created by Language version: $Revision: 1.6 $  of $Date: 1994/11/04 18:13:47 $ */
/* NOT VECTORIZED */
#include <stdio.h>
#include <math.h>
#include "scoplib.h"
#undef PI
 
#include "md1redef.h"
#include "section.h"
#include "md2redef.h"

#if METHOD3
extern int _method3;
#endif
 	/*SUPPRESS 761*/
	/*SUPPRESS 762*/
	/*SUPPRESS 763*/
	/*SUPPRESS 765*/
	 extern double *getarg();
 static double *_p; static Datum *_ppvar;
 
#define delta_t dt
#define gnabar _p[0]
#define gkbar _p[1]
#define gl _p[2]
#define el _p[3]
#define gna _p[4]
#define gk _p[5]
#define il _p[6]
#define m _p[7]
#define h _p[8]
#define n _p[9]
#define ena _p[10]
#define ek _p[11]
#define Dm _p[12]
#define Dh _p[13]
#define Dn _p[14]
#define ina _p[15]
#define ik _p[16]
#define _ion_ena	*_ppvar[0].pval
#define _ion_ina	*_ppvar[1].pval
#define _ion_dinadv	*_ppvar[2].pval
#define _ion_ek	*_ppvar[3].pval
#define _ion_ik	*_ppvar[4].pval
#define _ion_dikdv	*_ppvar[5].pval
 static int hoc_nrnpointerindex =  -1;
 /* external NEURON variables */
 extern double celsius;
 extern double dt;
 extern double t;
 /* declaration of user functions */
 static int _hoc_rates();
 static int _hoc_states();
 static int _hoc_trates();
 static int _hoc_vtrap();
 static int _mechtype;
extern int nrn_get_mechtype();
 static _hoc_setdata() {
 Prop *_prop, *hoc_getdata_range();
 _prop = hoc_getdata_range("hh");
 _p = _prop->param; _ppvar = _prop->dparam;
 ret(1.);
}
 /* connect user functions to hoc names */
 static IntFunc hoc_intfunc[] = {
 "setdata_hh", _hoc_setdata,
 "rates_hh", _hoc_rates,
 "states_hh", _hoc_states,
 "trates_hh", _hoc_trates,
 "vtrap_hh", _hoc_vtrap,
 0, 0
};
#define vtrap vtrap_hh
 extern double vtrap();
 /* declare global and static user variables */
#define htau htau_hh
 double htau = 0;
#define hinf hinf_hh
 double hinf = 0;
#define mtau mtau_hh
 double mtau = 0;
#define minf minf_hh
 double minf = 0;
#define ntau ntau_hh
 double ntau = 0;
#define ninf ninf_hh
 double ninf = 0;
#define usetable usetable_hh
 double usetable = 1;
 static double h0 = 0;
 static double m0 = 0;
 static double n0 = 0;
 static double t0 = 0;
 static double v = 0;
 /* connect global user variables to hoc */
 static DoubScal hoc_scdoub[] = {
 "minf_hh", &minf,
 "hinf_hh", &hinf,
 "ninf_hh", &ninf,
 "mtau_hh", &mtau,
 "htau_hh", &htau,
 "ntau_hh", &ntau,
 "usetable_hh", &usetable,
 0,0
};
 static DoubVec hoc_vdoub[] = {
 0,0,0
};
 static double _sav_indep;
 static nrn_alloc(), nrn_init(), nrn_cur(), nrn_state();
 /* connect range variables in _p that hoc is supposed to know about */
 static char *_mechanism[] = {
 "hh",
 "gnabar_hh",
 "gkbar_hh",
 "gl_hh",
 "el_hh",
 0,
 "gna_hh",
 "gk_hh",
 "il_hh",
 0,
 "m_hh",
 "h_hh",
 "n_hh",
 0,
 0};
 static Symbol* _na_sym;
 static Symbol* _k_sym;
 
static nrn_alloc(_prop)
	Prop *_prop;
{
	Prop *prop_ion, *need_memb();
	double *_p; Datum *_ppvar;
 	_p = (double *)ecalloc(17, sizeof(double));
 	_prop->param = _p;
 	_prop->param_size = 17;
 	/*initialize range parameters*/
 	gnabar = 0.12;
 	gkbar = 0.036;
 	gl = 0.0003;
 	el = -54.3;
 	_ppvar = (Datum *)ecalloc(6, sizeof(Datum));
 	_prop->dparam = _ppvar;
 	/*connect ionic variables to this model*/
 prop_ion = need_memb(_na_sym);
 nrn_promote(prop_ion, 0, 1);
 	_ppvar[0].pval = &prop_ion->param[0]; /* ena */
 	_ppvar[1].pval = &prop_ion->param[3]; /* ina */
 	_ppvar[2].pval = &prop_ion->param[4]; /* _ion_dinadv */
 prop_ion = need_memb(_k_sym);
 nrn_promote(prop_ion, 0, 1);
 	_ppvar[3].pval = &prop_ion->param[0]; /* ek */
 	_ppvar[4].pval = &prop_ion->param[3]; /* ik */
 	_ppvar[5].pval = &prop_ion->param[4]; /* _ion_dikdv */
 
}
 static _initlists();
 _hh_reg() {
	int _vectorized = 0;
  _initlists();
 	ion_reg("na", -10000.);
 	ion_reg("k", -10000.);
 	_na_sym = hoc_lookup("na_ion");
 	_k_sym = hoc_lookup("k_ion");
 	register_mech(_mechanism, nrn_alloc, nrn_cur, nrn_state, nrn_init, hoc_nrnpointerindex, _vectorized);
 _mechtype = nrn_get_mechtype(_mechanism[0]);
 	hoc_register_var(hoc_scdoub, hoc_vdoub, hoc_intfunc);
 	ivoc_help("help ?1 hh /timshel2h/home/hines/nrn/src/nrnoc/hh.mod\n");
 }
 static double _lmexp , _lhexp , _lnexp ;
 static double _lq10 ;
 static double *_t_minf;
 static double *_t__lmexp;
 static double *_t_hinf;
 static double *_t__lhexp;
 static double *_t_ninf;
 static double *_t__lnexp;
static int _reset;
static char *modelname = "hh.mod   squid sodium, potassium, and leak channels";

static int error;
static int _ninits = 0;
static int _match_recurse=1;
static _modl_cleanup(){ _match_recurse=1;}
static _f_trates();
static rates();
static states();
static trates();
 static _check_trates();
 static _n_trates();
 
static int  states (  )  {
   trates (  v ) ;
   m = m + _lmexp * ( minf - m ) ;
   h = h + _lhexp * ( hinf - h ) ;
   n = n + _lnexp * ( ninf - n ) ;
   
/*VERBATIM*/

        return 0;
  return 0; }
 static int _hoc_states() {
 double _r;
 _r = 1.;
 states (  ) ;
 ret(_r);
}
 
static int  rates (  _lv )  
	double _lv ;
 {
   double _lalpha , _lbeta , _lsum ;
 _lq10 = pow( 3.0 , ( ( celsius - 6.3 ) / 10.0 ) ) ;
   _lalpha = .1 * vtrap (  - ( _lv + 40.0 ) , 10.0 ) ;
   _lbeta = 4.0 * exp ( - ( _lv + 65.0 ) / 18.0 ) ;
   _lsum = _lalpha + _lbeta ;
   mtau = 1.0 / _lsum ;
   minf = _lalpha / _lsum ;
   _lalpha = .07 * exp ( - ( _lv + 65.0 ) / 20.0 ) ;
   _lbeta = 1.0 / ( exp ( - ( _lv + 35.0 ) / 10.0 ) + 1.0 ) ;
   _lsum = _lalpha + _lbeta ;
   htau = 1.0 / _lsum ;
   hinf = _lalpha / _lsum ;
   _lalpha = .01 * vtrap (  - ( _lv + 55.0 ) , 10.0 ) ;
   _lbeta = .125 * exp ( - ( _lv + 65.0 ) / 80.0 ) ;
   _lsum = _lalpha + _lbeta ;
   ntau = 1.0 / _lsum ;
   ninf = _lalpha / _lsum ;
    return 0; }
 static int _hoc_rates() {
 double _r;
 _r = 1.;
 rates (  *getarg(1) ) ;
 ret(_r);
}
 static double _mfac_trates, _tmin_trates;
 static _check_trates() {
  static int _maktable=1; int _i, _j, _ix = 0;
  double _xi, _tmax;
  static double _sav_dt;
  static double _sav_celsius;
  if (!usetable) {return;}
  if (_sav_dt != dt) { _maktable = 1;}
  if (_sav_celsius != celsius) { _maktable = 1;}
  if (_maktable) { double _x, _dx; _maktable=0;
   _tmin_trates =  - 100.0 ;
   _tmax =  100.0 ;
   _dx = (_tmax - _tmin_trates)/200.; _mfac_trates = 1./_dx;
   for (_i=0, _x=_tmin_trates; _i < 201; _x += _dx, _i++) {
    _f_trates(_x);
    _t_minf[_i] = minf;
    _t__lmexp[_i] = _lmexp;
    _t_hinf[_i] = hinf;
    _t__lhexp[_i] = _lhexp;
    _t_ninf[_i] = ninf;
    _t__lnexp[_i] = _lnexp;
   }
   _sav_dt = dt;
   _sav_celsius = celsius;
  }
 }

 static trates(_lv) double _lv;{ _check_trates();
 _n_trates(_lv);
 return;
 }

 static _n_trates(_lv) double _lv;{ int _i, _j;
 double _xi, _theta;
 if (!usetable) {
 _f_trates(_lv); return; 
}
 _xi = _mfac_trates * (_lv - _tmin_trates);
 _i = (int) _xi;
 if (_xi <= 0.) {
 minf = _t_minf[0];
 _lmexp = _t__lmexp[0];
 hinf = _t_hinf[0];
 _lhexp = _t__lhexp[0];
 ninf = _t_ninf[0];
 _lnexp = _t__lnexp[0];
 return; }
 if (_i >= 200) {
 minf = _t_minf[200];
 _lmexp = _t__lmexp[200];
 hinf = _t_hinf[200];
 _lhexp = _t__lhexp[200];
 ninf = _t_ninf[200];
 _lnexp = _t__lnexp[200];
 return; }
 _theta = _xi - (double)_i;
 minf = _t_minf[_i] + _theta*(_t_minf[_i+1] - _t_minf[_i]);
 _lmexp = _t__lmexp[_i] + _theta*(_t__lmexp[_i+1] - _t__lmexp[_i]);
 hinf = _t_hinf[_i] + _theta*(_t_hinf[_i+1] - _t_hinf[_i]);
 _lhexp = _t__lhexp[_i] + _theta*(_t__lhexp[_i+1] - _t__lhexp[_i]);
 ninf = _t_ninf[_i] + _theta*(_t_ninf[_i+1] - _t_ninf[_i]);
 _lnexp = _t__lnexp[_i] + _theta*(_t__lnexp[_i+1] - _t__lnexp[_i]);
 }

 
static int  _f_trates (  _lv )  
	double _lv ;
 {
   double _ltinc ;
 rates (  _lv ) ;
   _ltinc = - dt * _lq10 ;
   _lmexp = 1.0 - exp ( _ltinc / mtau ) ;
   _lhexp = 1.0 - exp ( _ltinc / htau ) ;
   _lnexp = 1.0 - exp ( _ltinc / ntau ) ;
    return 0; }
 static int _hoc_trates() {
 double _r;
  _r = 1.;
 trates (  *getarg(1) ) ;
 ret(_r);
}
 
double vtrap (  _lx , _ly )  
	double _lx , _ly ;
 {
   double _lvtrap;
 if ( fabs ( _lx / _ly ) < 1e-6 ) {
     _lvtrap = _ly * ( 1.0 - _lx / _ly / 2.0 ) ;
     }
   else {
     _lvtrap = _lx / ( exp ( _lx / _ly ) - 1.0 ) ;
     }
   
return _lvtrap;
 }
 static int _hoc_vtrap() {
 double _r;
 _r =  vtrap (  *getarg(1) , *getarg(2) ) ;
 ret(_r);
}

static initmodel() {
  int _i; double _save;_ninits++;
 _save = t;
 t = t0;
{
  h = h0;
  m = m0;
  n = n0;
 {
   trates (  v ) ;
   m = minf ;
   h = hinf ;
   n = ninf ;
   }
  _sav_indep = t; t = _save;

}
}

static nrn_init(_nd, _pp, _ppd) Node *_nd; double *_pp; Datum* _ppd; {
 double _v;
 _p = _pp; _ppvar = _ppd;
 _v = _nd->_v;
 v = _v;
  ena = _ion_ena;
  ek = _ion_ek;
 initmodel();
  }

static double _nrn_current(_v) double _v;{double _current=0.;v=_v;{ {
   gna = gnabar * m * m * m * h ;
   ina = gna * ( v - ena ) ;
   gk = gkbar * n * n * n * n ;
   ik = gk * ( v - ek ) ;
   il = gl * ( v - el ) ;
   }
 _current += ina;
 _current += ik;
 _current += il;

} return _current;
}

static nrn_cur(_nd, _pp, _ppd) Node *_nd;double *_pp; Datum* _ppd; {
 double _g, _rhs, _v, *_pdiag;
 _p = _pp; _ppvar = _ppd;
_pdiag = &_nd->_d;
 _v = _nd->_v;
  ena = _ion_ena;
  ek = _ion_ek;
 _g = _nrn_current(_v + .001);
 	{ static double _dik;
 static double _dina;
  _dina = ina;
  _dik = ik;
 _rhs = _nrn_current(_v);
  _ion_dinadv += (_dina - ina)/.001 ;
  _ion_dikdv += (_dik - ik)/.001 ;
 	}
 _g = (_g - _rhs)/.001;
  _ion_ina += ina ;
  _ion_ik += ik ;
 _rhs -= _g*_v;
 *_pdiag += _g;
 _nd->_rhs -= _rhs;
 
}

static nrn_state(_nd, _pp, _ppd) Node *_nd; double *_pp; Datum* _ppd; {
 double _break, _save;
 double _v;
 _p = _pp; _ppvar = _ppd;
 _v = _nd->_v;
 _break = t + .5*dt; _save = t; delta_t = dt;
 v=_v;
{
  ena = _ion_ena;
  ek = _ion_ek;
 { {
 for (; t < _break; t += delta_t) {
 error =  states();
 if(error){fprintf(stderr,"at line 65 in file hh.mod:\n        SOLVE states\n"); nrn_complain(_p); abort_run(error);}
 
}}
 t = _save;
 }  
}
}

static terminal(){}

static _initlists() {
 int _i; static int _first = 1;
  if (!_first) return;
   _t_minf = makevector(201*sizeof(double));
   _t__lmexp = makevector(201*sizeof(double));
   _t_hinf = makevector(201*sizeof(double));
   _t__lhexp = makevector(201*sizeof(double));
   _t_ninf = makevector(201*sizeof(double));
   _t__lnexp = makevector(201*sizeof(double));
_first = 0;
}
