#import <math.h>
#import "UserPath.h"
#import <appkit/appkit.h>

struct ctxtInfo{
    float c1x, c1y, c2x, c2y;
    float winCTM[6];
    int realWinNum;
};
typedef struct ctxtInfo ctxtInfo;

@interface VecView : View
{
    UserPath	*userPath;
    int		manual;
    ctxtInfo	theInfo;
}

/* instance methods */
- initFrame:(const NXRect *)rect;
- (NXRect*)bounds;
- (ctxtInfo*)thectxtInfo;
- printPSCode:sender;
- free;
- printtext:(float)xpos: (float)ypos: (char*)s;
- setscale:(float)scale;
- initGState;
- (float)width;
- (float)height;
- (UserPath *) startVec;
- drawVec;
- drawLine:(float)x1:(float)y1:(float)x2:(float)y2;
- drawPoint:(float)x1:(float)y1;
- clearArea:(NXRect*)aRect;
- clear;
- doClear:sender;
- setManual:(BOOL)bool;
@end
