#ifndef occonf_h
#define occonf_h

/* return value of a signal handler */
#if NeXT || SUN3 || MIPS || __TURBOC__ == 0x150
#define SIG_RETURN_TYPE	int
#else
#define SIG_RETURN_TYPE	void
#endif

/* existance of segmentation violation signal */
#if SUN3 || defined(__TURBOC__)
#define HAS_SIGSEGV	0
#else
#define HAS_SIGSEGV	1
#endif

/* existance of bus error signal */
#if SUN3 || defined(__TURBOC__) || LINUX
#define HAS_SIGBUS	0
#else
#define HAS_SIGBUS	1
#endif

/* include file that delares malloc, realloc, and calloc */
#if defined(__TURBOC__)
#define INCLUDE_ALLOC_H 1
#else
#ifndef NeXT
#define INCLUDE_MALLOC_H 1
#endif
#endif

/* if strstr is not declared in <string.h> */
#if MIPS
#define NO_STRSTR 1
#endif

#endif
