/* $Header: /timshel2g/src/master/nrn/src/oc/redef.h,v 1.3 1994/10/28 15:18:01 hines Exp $ */
/*
$Log: redef.h,v $
 * Revision 1.3  1994/10/28  15:18:01  hines
 * yet another common name defined in an include file. this time ALPHA
 *
 * Revision 1.2  1994/10/26  17:25:06  hines
 * access name changed to an explicit hoc_access and taken out of redef.h
 *
 * Revision 1.1.1.1  1994/10/12  17:22:04  hines
 * NEURON 3.0 distribution
 *
 * Revision 2.80  1994/04/06  17:14:24  hines
 * minor changes to structures to allow checkpointing in ivoc
 * basically no more codepfd
 *
 * Revision 1.1  1991/10/11  11:12:30  hines
 * Initial revision
 *
 * Revision 3.46  90/01/24  06:38:15  mlh
 * emalloc() and ecalloc() are macros which return null if out of space
 * and then call execerror.  This ensures that pointers are set to null.
 * If more cleanup necessary then use hoc_Emalloc() followed by hoc_malchk()
 * 
 * Revision 3.27  89/09/29  16:00:19  mlh
 * ecalloc needed in some places to initialize allocated space
 * 
 * Revision 3.16  89/08/10  11:17:10  mlh
 * push and pop integers on the stack
 * 
 * Revision 3.7  89/07/13  08:21:53  mlh
 * stack functions involve specific types instead of Datum
 * 
 * Revision 3.4  89/07/12  10:28:18  mlh
 * Lint free
 * 
 * Revision 2.0  89/07/07  11:32:57  mlh
 * Preparation for newcable
 * 
 * Revision 1.1  89/07/07  11:17:40  mlh
 * Initial revision
 * 
*/

/* version 7.2.1 2-jan-89 */
# define	Break	hoc_Break
# define	Continue	hoc_Continue
# define	Exp	hoc_Exp
# define	Fprint	hoc_Fprint
# define	Fscan	hoc_Fscan
# define	Log	hoc_Log
# define	Log10	hoc_Log10
# define	Plt	hoc_Plt
# define	color	hoc_color
# define	Setcolor hoc_Setcolor
# define	Pow	hoc_Pow
# define	PRintf	hoc_PRintf
# define	Sqrt	hoc_Sqrt
# define	System	hoc_System
# define	Xred	hoc_Xred
# define	acterror	hoc_acterror
# define	add	hoc_add
# define	and	hoc_and
# define	arayinstal	hoc_arayinstal
# define	araypt	hoc_araypt
# define	arg	hoc_arg
# define	argassign	hoc_argassign
# define	assign	hoc_assign
# define	assstr	hoc_assstr
# define	backslash	hoc_backslash
# define	begin	hoc_begin
# define	bltin	hoc_bltin
# define	call	hoc_call
# define	cbuf	hoc_cbuf
# define	Code	hoc_Code
# define	codei	hoc_codei
# define	codesym	hoc_codesym
# define	codein	hoc_codein
# define	constpush	hoc_constpush
# define	pushzero	hoc_pushzero
# define	ctp	hoc_ctp
# define	debug	hoc_debug
# define	debugzz	hoc_debugzz
# define	defnonly	hoc_defnonly
# define	dep_make	hoc_dep_make
# define	do_equation	hoc_do_equation
# define	edit	hoc_edit
# define	eq	hoc_eq
# define	eqinit	hoc_eqinit
# define	eqn_init	hoc_eqn_init
# define	eqn_lhs	hoc_eqn_lhs
# define	eqn_name	hoc_eqn_name
# define	eqn_rhs	hoc_eqn_rhs
# define	eqn_side	hoc_eqn_side
# define	eqn_space	hoc_eqn_space
# define	errcheck	hoc_errcheck
# define	eval	hoc_eval
# define	execerror	hoc_execerror
# define	execute	hoc_execute
# define	fin	hoc_fin
# define	follow	hoc_follow
# define	forcode	hoc_forcode
# define	shortfor	hoc_shortfor
# define	fout	hoc_fout
# define	fpecatch	hoc_fpecatch
# define	free_list	hoc_free_list
# define	frin	hoc_frin
# define	funcret	hoc_funcret
# define	gargc	hoc_gargc
# define	gargv	hoc_gargv
# define	ge	hoc_ge
# define	getnb	hoc_getnb
# define	gt	hoc_gt
# define	ifcode	hoc_ifcode
# define	indef	hoc_indef
# define	infile	hoc_infile
# define	init	hoc_init
# define	init_access	hoc_init_access
# define	initcode	hoc_initcode
# define	install	hoc_install
# define	integer	hoc_integer
# define	intset	hoc_intset
# define	le	hoc_le
# define	lineno	hoc_lineno
# define	lookup	hoc_lookup
# define	lt	hoc_lt
# define	moreinput	hoc_moreinput
# define	mul	hoc_mul
# define	ne	hoc_ne
# define	negate	hoc_negate
# define	not	hoc_not
# define	onintr	hoc_onintr
# define	or	hoc_or
# define	p_symlist	hoc_p_symlist
# define	parserror	hoc_parserror
# define	pc	hoc_pc
# define	pipeflag	hoc_pipeflag
# define	pipeflush	hoc_pipeflush
# define	pipegetc	hoc_pipegetc
# define	pipeungetc	hoc_pipeungetc
# define	xpop	hoc_xpop
# define	spop	hoc_spop
# define	ipop	hoc_ipop
# define	nopop	hoc_nopop
# define	power	hoc_power
# define	prexpr	hoc_prexpr
# define	print	hoc_print
# define	procret	hoc_procret
# define	prog		hoc_prog
# define	prog_parse_recover	hoc_prog_parse_recover
# define	progbase	hoc_progbase
# define	progname	hoc_progname
# define	progp	hoc_progp
# define	prstr	hoc_prstr
# define	pushx	hoc_pushx
# define	pushs	hoc_pushs
# define	pushi	hoc_pushi
# define	ret	hoc_ret
# define	ropen	hoc_ropen
# define	run	hoc_run
# define	set_varble	hoc_set_varble
# define	solve	hoc_solve
# define	spinit	hoc_spinit
# define	sprint	hoc_sprint1
# define	sub	hoc_sub
# define	symbols	hoc_symbols
# define	symlist	hoc_symlist
# define	var_access	hoc_var_access
# define	varpush	hoc_varpush
# define	varread	hoc_varread
# define	warning	hoc_warning
# define	wopen	hoc_wopen
# define	xopen	hoc_xopen
# define	zzdebug	hoc_zzdebug
